local startRaid = false

local BUFFS = {
    ["22888"] = {
        name = "Rallying Cry of the Dragonslayer",
        type = "Worldbuff"
    },
    ["16609"] = {
        name = "Warchief's Blessing",
        type = "Worldbuff"
    },
    ["15366"] = {
        name = "Songflower Serenade",
        type = "Worldbuff",
    },
    ["22817"] = {
        name = "Fengus' Ferocity",
        type = "Worldbuff",
    },
    ["22820"] = {
        name = "Slip'kik's Savvy",
        type = "Worldbuff",
    },
    ["22818"] = {
        name = "Mol'dar's Moxie",
        type = "Worldbuff",
    },
    ["17628"] = {
        name = "Supreme Power",
        type = "Flask",
    },
    ["17626"] = {
        name = "Flask of the Titans",
        type = "Flask",
    },
    ["17627"] = {
        name = "Distilled Wisdom",
        type = "Flask",
    },
}

function Ragequit:GROUP_ROSTER_UPDATE()
    if isOfficerLoaded then
        if (IsInRaid() == false) and startRaid then
            DEFAULT_CHAT_FRAME:AddMessage("Ragequit: Konvertert til Raid")
            ConvertToRaid()
            startRaid = false
        end
    end
end

function Ragequit:CheckBuffs()
    if IsInRaid() then
        local players = {}

        for i = 1, 40 do
            name, _, group = GetRaidRosterInfo(i)
            if name then
                Ragequit:CheckUnitBuffs(players,"raid" .. i)
            end
        end

        local output = ""

        for i, v in pairs(players) do
            output = output .. i .. " # "
            output = output .. table.concat(players[i], ", ") .. "\n"
        end

        local dialog = StaticPopup_Show("RQCOPY")
        local editBox = dialog.editBox
        editBox:SetText(output)
        editBox:HighlightText()
        editBox:SetFocus()
    else
        DEFAULT_CHAT_FRAME:AddMessage("Not in Raid")
    end
end

function Ragequit:CheckUnitBuffs(players, unit)
    for i = 1, 40 do
        local buffName, _, _, _, _, _, _, _, _, spellId = UnitBuff(unit, i)
        if spellId then 
            spellId = tostring(spellId)
            local trackedBuff = BUFFS[spellId]
            if trackedBuff then 
                if not players[name] then players[name] = {} end
                table.insert(players[name], trackedBuff.name)
            end
        end
    end
end

local function manaClass(raidbuffs, players, name)
    -- motw / gotw    
    if (raidbuffs["9885"] == nil) and (raidbuffs["21850"] == nil) then
        if not players["MotW"] then players["MotW"] = {} end
        table.insert(players["MotW"], name)
    end

    -- Prayer of spirit /
    if (raidbuffs["27681"] == nil) and (raidbuffs["27841"] == nil) then
        if not players["Spirit"] then players["Spirit"] = {} end
        table.insert(players["Spirit"], name)
    end

    -- Prayer of fortitude /
    if (raidbuffs["21564"] == nil) and (raidbuffs["10938"] == nil) then
        if not players["Fortitude"] then players["Fortitude"] = {} end
        table.insert(players["Fortitude"], name)
    end

    -- Arcane Intellect / Arcane Brilliance
    if (raidbuffs["10157"] == nil) and (raidbuffs["23028"] == nil) then
        if not players["Intellect"] then players["Intellect"] = {} end
        table.insert(players["Intellect"], name)
    end
end

local function notManaClass(raidbuffs, players, name)
    -- motw / gotw    
    if (raidbuffs["9885"] == nil) and (raidbuffs["21850"] == nil) then
        if not players["MotW"] then players["MotW"] = {} end
        table.insert(players["MotW"], name)
    end

    -- Prayer of fortitude /
    if (raidbuffs["21564"] == nil) and (raidbuffs["10938"] == nil) then
        if not players["Fortitude"] then players["Fortitude"] = {} end
        table.insert(players["Fortitude"], name)
    end
end

function Ragequit:MergeBuffNeeded(tbl, output, buff)
    if tbl ~= nil then
        local count = tablelength(tbl)

        if tablelength(tbl) < 8 then
            return output .. buff .. ": " .. table.concat(tbl, ", ") .. "\n"
        else
            return output .. string.format("%s: %s stk mangler\n", buff, count)
        end
    end

    return output
end

function Ragequit:CheckRaidBuffs()
    if IsInRaid() then
        local players = {}

        for i = 1, 40 do
            name, _, group = GetRaidRosterInfo(i)
            if name then
                Ragequit:CheckUnitRaidBuffs(players, "raid" .. i, name)
            end
        end

        local output = "" 

        if next(players) == nil then
            output = output .. "Vi er buffa! (MotW, Spirit, Fortitude og Intellect)" .. "\n"
        else
            output = output .. "Mangler raid buffs:" .. "\n"

            output = Ragequit:MergeBuffNeeded(players["MotW"], output, "MotW")
            output = Ragequit:MergeBuffNeeded(players["Spirit"], output, "Spirit")
            output = Ragequit:MergeBuffNeeded(players["Fortitude"], output, "Fortitude")
            output = Ragequit:MergeBuffNeeded(players["Intellect"], output, "Intellect")
        end

        return output
    else
        return "Not in a raid"
    end
end

function Ragequit:CheckUnitRaidBuffs(players, unit, name)
    local localizedClass, englishClass = UnitClass(unit);
    local raidbuffs = {}

    for i = 1, 40 do
        local buffName, _, _, _, _, _, _, _, _, spellId = UnitBuff(unit, i)
        if spellId then 
            spellId = tostring(spellId)
            raidbuffs[spellId] = buffName
        end
    end

    if englishClass == "WARRIOR" then
        notManaClass(raidbuffs, players, name)
    elseif englishClass == "SHAMAN" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "PRIEST" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "MAGE" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "DRUID" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "HUNTER" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "WARLOCK" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "ROGUE" then
        notManaClass(raidbuffs, players, name)
    end
end

function Ragequit:GuildMembers()

    local numTotalMembers, numOnlineMaxLevelMembers, numOnlineMembers = GetNumGuildMembers();

    local str = ""
    local players = {}

    for i = 0, GetNumGuildMembers() do
        local name, rank, rankIndex, level, class = GetGuildRosterInfo(i);

        if ((name ~= nil) and ((rank ~= nil) and (class ~= nil))) then
            table.insert(players, stripRealm(name) .. ',' .. rank .. ',' .. class )
        end
    end

    table.sort(players)
    table.insert(players, 1, 'Name,Rank,Class')

    for player = 0, #players do
        if(players[player] ~= nil) then
            str = str .. players[player] .. "\n"
        end
    end
    
    local dialog = StaticPopup_Show("RQCOPY")
    local editBox = dialog.editBox
    editBox:SetText(Ragequit:Encode(str))
    editBox:HighlightText()
    editBox:SetFocus()
end

function Ragequit:RaidMembers()
    if(IsInRaid()) then
        local str = ""
        local players = {}

        local prefix = IsInRaid() and "raid" or "party"
        for i = 1, GetNumGroupMembers() do
            local unit = prefix .. i
            local name = UnitName(unit)

            if (name ~= nil) then
                players[i] = name
            end
        end

        table.sort(players)

        for playerCount = 1, #players do
          str = str .. players[playerCount] .. "\n"
        end
        
        local dialog = StaticPopup_Show("RQEXPORT")
        local editBox = dialog.editBox
        editBox:SetText(str)
        editBox:HighlightText()
        editBox:SetFocus()
    else
        print ("Not in Raid")
    end
end

function Ragequit:Invite(text)
    if not isEmpty(text) then
        local invite = splitString(text, ",")

        if (table.getn(invite) ~= 0) then
            startRaid = true
            DEFAULT_CHAT_FRAME:AddMessage("Starter invites")

            C_Timer.After(10, function () 
                if isOfficerLoaded then
                    if (IsInRaid() == false) and (IsInGroup() == false) then
                        startRaid = false
                    end
                end
            end)

            for i = 1, #invite do
                InviteUnit(invite[i])
            end
        end
    end
end